/*
 * types.h - Type definitions.
 *
 * Copyright (c) 2003 M. R. Brown <mrbrown@0xd6.org>
 *
 * This code is licensed under the LGPL version 2.  See the file
 * "COPYING.LGPL" in the main directory of this archive for more information.
 */
#ifndef _TYPES_H_
#define _TYPES_H_

#if !defined(s8) && !defined(u8)
typedef __signed__ char __s8;
typedef unsigned char __u8;
#define s8 __s8
#define u8 __u8
#endif

#if !defined(s16) && !defined(u16)
typedef __signed__ short __s16;
typedef unsigned short __u16;
#define s16 __s16
#define u16 __u16
#endif

#if !defined(s32) && !defined(u32)
typedef __signed__ int __s32;
typedef unsigned int __u32;
#define s32 __s32
#define u32 __u32
#endif

#if !defined(s64) && !defined(u64)
typedef __signed__ /*long*/ long __s64;
typedef unsigned /*long*/ long __u64;
#define s64 __s64
#define u64 __u64
#endif

#if !defined(s128) && !defined(u128)
typedef __signed__ int __s128 __attribute__((mode(TI), aligned(16)));
typedef unsigned int __u128 __attribute__((mode(TI), aligned(16)));
#define s128 __s128
#define u128 __u128
#endif

#endif /* _TYPES_H_ */
